#include "CVME.h"
#include "TVMEInterface.h"

#ifndef VMEUS_H
#define VMEUS_H

class TVMEUS : public TVMEInterface
{
//private:
     bt_error_t mError;
      CVME * pVme;
public:

    TVMEUS(CVME* vme): pVme(vme) {};
    virtual ~TVMEUS() {};

    virtual void Reset() {};
    virtual void Write (unsigned long int address, char * data, size_t  count) {};
    virtual void Write32 (unsigned long int address, unsigned long int  value)
        {
         mError = pVme->Write(address, value);
		 if(mError!= BT_SUCCESS)
			 throw EVMEWrite( CheckVMEStatus(mError) ); 
        };

    virtual void Write16 (unsigned long int address, unsigned short int value)
        {
         mError = pVme->Write(address, value);
		 if(mError!= BT_SUCCESS)
			 throw EVMEWrite( CheckVMEStatus(mError) ); 
        };

    virtual void Read (unsigned long int address, char * data, size_t count) {};

    virtual unsigned long  Read32 (unsigned long int address)
        {
         unsigned long value;
		 mError = pVme->Read(address, &value);
		  if(mError!= BT_SUCCESS)
			 throw EVMERead( CheckVMEStatus(mError) );
		 return value;
        };

    virtual unsigned short Read16 (unsigned long int address)
        {
         unsigned long value;
	 mError = pVme->Read(address, &value);
	 		  if(mError!= BT_SUCCESS)
			 throw EVMERead( CheckVMEStatus(mError) );
	 return value;
        };

        //Error testing function
	char* CheckVMEStatus(bt_error_t status)
		{
		if (status != BT_SUCCESS) {

			char *error_desc;
		   error_desc = bt_strerror(Btd, status, "", Buffer, BUF_SIZE );
			if (error_desc == NULL)
				return "error description anavailable";
			else 
				return error_desc;
		}
	
		return NULL;
		}

    
};

#endif

